/*********************************************************************
* Copyright (c) 2023 Contributors to the Eclipse Foundation.
*
* This program and the accompanying materials are made
* available under the terms of the Eclipse Public License 2.0
* which is available at https://www.eclipse.org/legal/epl-2.0/
*
* SPDX-License-Identifier: EPL-2.0
*
* Contributors:
*   Kentyou - initial implementation
**********************************************************************/
package org.eclipse.sensinact.core.emf.model;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.sensinact.core.model.SensinactModelManager;

/**
 * The sensiNact interface used to create and discover the models using EMF
 */
public interface SensinactEMFModelManager extends SensinactModelManager {

    EMFModel getModel(String model);

    EMFModel getModel(String modelPackageUri, String model);

    EMFModel getModel(EClass eClass);

    EMFModelBuilder createModel(EClass eClass);

    EMFModelBuilder createModel(String model);

    EMFModelBuilder createModel(String modelPackageUri, String model);

}
