/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.sensinact.model.core.provider.impl.ProviderImpl;

import org.eclipse.sensinact.model.core.testdata.TestSensor;
import org.eclipse.sensinact.model.core.testdata.TestTemperatur;
import org.eclipse.sensinact.model.core.testdata.TestdataPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Test Sensor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.impl.TestSensorImpl#getTemp <em>Temp</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.impl.TestSensorImpl#getTempNonContaint <em>Temp Non Containt</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TestSensorImpl extends ProviderImpl implements TestSensor {
	/**
	 * The cached value of the '{@link #getTemp() <em>Temp</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTemp()
	 * @generated
	 * @ordered
	 */
	protected TestTemperatur temp;

	/**
	 * The cached value of the '{@link #getTempNonContaint() <em>Temp Non Containt</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTempNonContaint()
	 * @generated
	 * @ordered
	 */
	protected TestTemperatur tempNonContaint;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TestSensorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TestdataPackage.Literals.TEST_SENSOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestTemperatur getTemp() {
		return temp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTemp(TestTemperatur newTemp, NotificationChain msgs) {
		TestTemperatur oldTemp = temp;
		temp = newTemp;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, TestdataPackage.TEST_SENSOR__TEMP, oldTemp, newTemp);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTemp(TestTemperatur newTemp) {
		if (newTemp != temp) {
			NotificationChain msgs = null;
			if (temp != null)
				msgs = ((InternalEObject)temp).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - TestdataPackage.TEST_SENSOR__TEMP, null, msgs);
			if (newTemp != null)
				msgs = ((InternalEObject)newTemp).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - TestdataPackage.TEST_SENSOR__TEMP, null, msgs);
			msgs = basicSetTemp(newTemp, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TestdataPackage.TEST_SENSOR__TEMP, newTemp, newTemp));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestTemperatur getTempNonContaint() {
		if (tempNonContaint != null && tempNonContaint.eIsProxy()) {
			InternalEObject oldTempNonContaint = (InternalEObject)tempNonContaint;
			tempNonContaint = (TestTemperatur)eResolveProxy(oldTempNonContaint);
			if (tempNonContaint != oldTempNonContaint) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TestdataPackage.TEST_SENSOR__TEMP_NON_CONTAINT, oldTempNonContaint, tempNonContaint));
			}
		}
		return tempNonContaint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TestTemperatur basicGetTempNonContaint() {
		return tempNonContaint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTempNonContaint(TestTemperatur newTempNonContaint) {
		TestTemperatur oldTempNonContaint = tempNonContaint;
		tempNonContaint = newTempNonContaint;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TestdataPackage.TEST_SENSOR__TEMP_NON_CONTAINT, oldTempNonContaint, tempNonContaint));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TestdataPackage.TEST_SENSOR__TEMP:
				return basicSetTemp(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TestdataPackage.TEST_SENSOR__TEMP:
				return getTemp();
			case TestdataPackage.TEST_SENSOR__TEMP_NON_CONTAINT:
				if (resolve) return getTempNonContaint();
				return basicGetTempNonContaint();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TestdataPackage.TEST_SENSOR__TEMP:
				setTemp((TestTemperatur)newValue);
				return;
			case TestdataPackage.TEST_SENSOR__TEMP_NON_CONTAINT:
				setTempNonContaint((TestTemperatur)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TestdataPackage.TEST_SENSOR__TEMP:
				setTemp((TestTemperatur)null);
				return;
			case TestdataPackage.TEST_SENSOR__TEMP_NON_CONTAINT:
				setTempNonContaint((TestTemperatur)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TestdataPackage.TEST_SENSOR__TEMP:
				return temp != null;
			case TestdataPackage.TEST_SENSOR__TEMP_NON_CONTAINT:
				return tempNonContaint != null;
		}
		return super.eIsSet(featureID);
	}

} //TestSensorImpl
